//const Markup = require('telegraf/markup.js')
const fs = require('fs')
const path  = require('path')
const lineByLine = require('n-readlines')
const dateFormat = require('dateformat')
const {TOKEN,VOICES_DIR} = require('./config')
const {URI_WIT,ACCESS_TOKEN} = require('./config')
const request = require('request')
const req_pro = require('request-promise')
const https = require('https'); 
const ffmpeg = require('fluent-ffmpeg');
const temp = require('temp');
const nodeCmd = require('node-cmd');
const witai_speech = require('witai-speech')
const sleep  = require('await-sleep')
const WitSpeech = require('node-witai-speech')
const FormData = require('form-data')
const sox =require('sox')
const SoxCommand = require('sox-audio')

const{showTask, addTask, deleteTask, getMyTasks, clearTasks,countTasks} = require('./db.js')
var OGG

const urlt = 'https://api.telegram.org/bot' + TOKEN + '/getFile?file_id='
const urltfp = 'https://api.telegram.org/file/bot' + TOKEN + '/'




function sp(ctx){
let rt
let out_file, file_loc
let u = urlt + ctx.message.voice.file_id
request.post({url:u} ,function(error, response, body) {
    console.log("Response POST Status code : ",response.statusCode)
    if (error) throw err;
       body =  JSON.parse(body)
///////Get file path    
//body =  JSON.parse(body)
let    path=body.result.file_path
console.log("PATH: ",path)
let str = path.split('/')
let g = urltfp + path
file_loc=__dirname +  VOICES_DIR + str[1]
let file = fs.createWriteStream(file_loc);

const res_get = https.get(g, function(resg, err) {
    if (err) throw err;
//console.log('Response GET:',response)
console.log("Response GET file_path code:", resg.statusCode)
  resg.pipe(file)
  let name_spl = file_loc.split('.')    
  out_file = name_spl[0] +'.ogg'
//  convert_sox(file_loc,out_file,ctx)
   convert_sox45(file_loc,out_file,ctx)
//console.log('File_path', file_loc)
//console.log('Return:', out_file)
/*
ffmpeg.ffprobe(file_loc, (err, info) => {
//let stats = fs.statSync(file_loc)
//let fileSize = stats.size;
  ffmpeg()
//    .on('end', () => wit_decode_speech(out_file,'audio/ogg')  )
    .on('end', () => voice_to_speech(out_file,ctx)  )
    .input(file_loc)
    .setStartTime(0)
    .duration(body.result.file_size)
    .output(out_file)
    .audioFrequency('32000')
    .toFormat('ogg')
    .run();
});
*/
  

})        
///////End get file path////////////  
               })

}

function convert_sox(s,d,ctx){

var job = sox.transcode(s,d, {
//  sampleRate: 48000,
//  format: 'ogg',
//  channelCount: 1,
//  bitRate: 32000,
//  compressionQuality: 5, // see `man soxformat` search for '-C' for more info
});
job.on('error', function(err) {
  console.error(err);
});
job.on('progress', function(amountDone, amountTotal) {
  console.log("progress", amountDone, amountTotal);
});
job.on('src', function(info) {

//    duration: 1.5,
//    sampleCount: 66150,
//info looks like:
 
//  {
    format= 'oga'
    channelCount= 1
    bitRate= 32000
    sampleRate= 48000
 // }
/*  */
});
job.on('dest', function(info) {
 //  info looks like:
//    sampleCount: 67958,
//    duration: 1.540998,
//  {
    sampleRate= 48000
    format= 'ogg'
    channelCount= 1
    bitRate= 32000
//  }
 
});
job.on('end', function() {
  console.log("all done");
  voice_to_speech(d,ctx);
});
job.start();

}

function convert_sox45(inputStream,outputStream,ctx){

var command = SoxCommand();
command.input(inputStream)
 /*
  .inputSampleRate(48000)
  .inputEncoding('signed')
  .inputBits(16)
  .inputChannels(1)
  .inputFileType('oga');
  */
;  
command.output(outputStream)
 /*
  .outputSampleRate(48000)
  .outputEncoding('signed')
  .outputBits(16)
  .outputChannels(1)
  .outputFileType('ogg');
*/
;

command.on('prepare', function(args) {
  console.log('Preparing sox command with args ' + args.join(' '));
});

command.on('start', function(commandLine) {
  console.log('Spawned sox with command ' + commandLine);
});

command.on('progress', function(progress) {
  console.log('Processing progress: ', progress);
});

command.on('error', function(err, stdout, stderr) {
  console.log('Cannot process audio: ' + err.message);
  console.log('Sox Command Stdout: ', stdout);
  console.log('Sox Command Stderr: ', stderr)
});

command.on('end', function() {
  console.log('Sox command succeeded!');
 voice_to_speech(outputStream,ctx);
//  fun;
});

command.run();

}




function convert_sox46(inputStream,outputStream,ctx){

var command = SoxCommand();
command.input(inputStream)
 /*
  .inputSampleRate(48000)
  .inputEncoding('signed')
  .inputBits(16)
  .inputChannels(1)
  .inputFileType('oga');
  */
;  
command.output(outputStream)
 /*
  .outputSampleRate(48000)
  .outputEncoding('signed')
  .outputBits(16)
  .outputChannels(1)
  .outputFileType('ogg');
*/
;

command.on('prepare', function(args) {
  console.log('Preparing sox command with args ' + args.join(' '));
});

command.on('start', function(commandLine) {
  console.log('Spawned sox with command ' + commandLine);
});

command.on('progress', function(progress) {
  console.log('Processing progress: ', progress);
});

command.on('error', function(err, stdout, stderr) {
  console.log('Cannot process audio: ' + err.message);
  console.log('Sox Command Stdout: ', stdout);
  console.log('Sox Command Stderr: ', stderr)
});

command.on('end', function() {
  console.log('Sox command succeeded!');
// voice_to_speech(outputStream,ctx);
//  fun;
//console.log('voice: ',f_ogg)

//ctx.replyWithVoice({source:task},{caption:str_file})

ctx.replyWithVoice({source:outputStream},{caption:path.basename(outputStream)})

});

command.run();

}


function voice_to_speech(file,ctx){
let rs = ctx
var form = new FormData()
form.append("folder_id", "0")
form.append("filename", fs.createReadStream(file))
//form.append("filename", fs.createReadStream('/home/vv/node12/voice_bot/voices/file_210.ogg'));
form.getLength(function(err, length){
  if (err) {
    return requestCallback_to_speech(err);
  }
console.log('LEN: ',length);
//console.log('CTX: ',ctx.message);
  var r = request.post(URI_WIT, requestCallback_to_speech) 
  r._form = form
  r.setHeader('content-length', length)
  r.setHeader('Authorization', `Bearer ` + ACCESS_TOKEN)
  r.setHeader('Content-Type', 'audio/ogg')
  r.setHeader('Transfer-Encoding', 'chunked')

})


function requestCallback_to_speech(err, res, body) {
 console.log("BODY: ",body)
 console.log("OUT_FILE in Callback: ",file)
 body = JSON.parse(body)
  console.log("BODY_TEXT: ",body.text)
/*
BODY:  {
  "entities": {},
  "intents": [],
  "text": "привет",
  "traits": {}
}
*/
if(body.text == null){ ctx.reply(body.text + '.... не смог разобрать'); return}
let text = body.text.split(' ')
let len_text = text.length
console.log('Length array: ',len_text)  


switch(text[0]){
case 'скачать': down_load_file(ctx,text,len_text); break;
case 'включить': bitrix_On_Off(ctx,text,len_text); break;
case 'выключить': bitrix_On_Off(ctx,text,len_text); break; 
case 'битрикс': bitrix_On_Off(ctx,text,len_text); break;
case 'статус': bitrix_On_Off(ctx,text,len_text); break;

default: break;
}

ctx.reply(body.text)
}
}

function bitrix_On_Off(ctx,text,len_text){
let kw = 0 
let id = 0

switch(text[1]){

case 'включить':nodeCmd.get('./ON_OFF_BX24/on_bx24/on_bx24.sh',(err,data,stderr) => ctx.reply(data)) ;break;
case 'выключить':nodeCmd.get('./ON_OFF_BX24/off_bx24/off_bx24.sh',(err,data,stderr) => ctx.reply(data));break;
case 'битрикс':
if(text[0] === 'выключить'){
nodeCmd.get('./ON_OFF_BX24/off_bx24/off_bx24.sh',(err,data,stderr) => ctx.reply(data));break;}
else if(text[0] === 'включить'){
nodeCmd.get('./ON_OFF_BX24/on_bx24/on_bx24.sh',(err,data,stderr) => ctx.reply(data)) ;break}
else if(text[0] === 'статус'){

nodeCmd.get('./ON_OFF_BX24/status_bx24/status_bx24.sh',(err,data,stderr) =>
{
if(data.length===0){ctx.reply('Выключен')}
else{ctx.reply('Включен')}
})
}

case 'битрикса':
if(text[0] === 'статус'){
nodeCmd.get('./ON_OFF_BX24/status_bx24/status_bx24.sh',(err,data,stderr) =>
{
if(data.length===0){ctx.reply('Выключен')}
else{ctx.reply('Включен')}
})
}

default: break;

}
}

async function down_load_file(ctx,text,len_text){

let kw = 0 
let id = 0
for(let i = 1; i<len_text; i++){

switch(text[i]){

case 'ноль'           : kw=0;      break;
case 'раз'            : kw=1;      break;
case 'один'           : kw=1;      break;
case 'два'            : kw=2;      break;
case 'три'            : kw=3;      break;
case 'четыре'         : kw=4;      break;
case 'пять'           : kw=5;      break;
case 'шесть'          : kw=6;      break;
case 'семь'           : kw=7;      break;
case 'восемь'         : kw=8;      break;
case 'девять'         : kw=9;      break;


case  'десять'        : kw=10;     break;
case  'одинадцать'    : kw=11;     break;
case  'двенадцать'    : kw=12;     break;
case  'тринадцать'    : kw=13;     break;
case  'четырнадцать'  : kw=14;     break;
case  'пятнадцать'    : kw=15;     break;
case  'шестнадцать'   : kw=16;     break;
case  'семнадцать'    : kw=17;     break;
case  'восемнадцать'  : kw=18;     break;
case  'девятнадцать'  : kw=19;     break;

case  'двадцать'      : kw=20;     break;
case  'тридцать'      : kw=30;     break;
case  'сорок'         : kw=40;     break;
case  'пятьдесят'     : kw=50;     break;
case  'шестьдесят'    : kw=60;     break;
case  'семьдесят'     : kw=70;     break;
case  'восемьдесят'   : kw=80;     break;
case  'девяносто'     : kw=90;     break;
case  'сто'           : kw=100;    break;

case  'двести'        : kw=200;    break;
case  'триста'        : kw=300;    break;
case  'четыреста'     : kw=400;    break;
case  'пятьсот'       : kw=500;    break;
case  'шестьсот'      : kw=600;    break;
case  'семьсот'       : kw=700;    break;
case  'восемьсот'     : kw=800;    break;
case  'девятьсот'     : kw=900;    break;



default: ctx.reply('Не разобрал цифры'); i=len_text+1;    return;
}

id = id + kw 

}
console.log('KW from voice: ',kw)
const len = await  countTasks();
console.log('TASK id; ', id)
if(id > len || id==0){console.log(' return!!!');ctx.reply('Нет такого файла'); return }
else{
let task = showTask(id-1)
console.log('showTask ',task)

let str_file = path.basename(task)  

let w_ext = str_file.split('.')
let f_ogg = __dirname + VOICES_DIR + w_ext[0]+'.ogg'

convert_sox46(task,f_ogg,ctx)
 }


}



function wit_decode_speech(file_stream,content_type){
// Stream the file to be sent to the wit.ai
var stream = fs.createReadStream(file_stream);
//var stream = fs.createReadStream('/home/vv/node12/voice_bot/voices/file_210.ogg');
// The wit.ai instance api key
//var API_KEY = "ISDFWERSDFSDFSDFSDFSDFJIKM";
// The content-type for this audio stream (audio/wav, ...)
//var content_type = "audio/wav";
// Its best to return a promise
var parseSpeech =  new Promise((ressolve, reject) => {
    // call the wit.ai api with the created stream
    WitSpeech.extractSpeechIntent(ACCESS_TOKEN, stream, content_type, 
    (err, res) => {
        if (err) return reject(err);
        ressolve(res);
    });
});
// check in the promise for the completion of call to witai
parseSpeech.then((data) => {
    console.log(data);
    return data
})
.catch((err) => {
    console.log(err);
})
}




module.exports = {
sp:sp
}



