const Markup = require('telegraf/markup.js')
const fs = require('fs')
const path  = require('path')
const lineByLine = require('n-readlines')
const dateFormat = require('dateformat')
const {TOKEN,VOICES_DIR,CHAT_ID} = require('./config')
const request = require('request')
const req_pro = require('request-promise')
const https = require('https'); 
const ffmpeg = require('fluent-ffmpeg');
const temp = require('temp');
const nodeCmd = require('node-cmd');
const witai_speech = require('witai-speech')
const sleep  = require('await-sleep')



function getBx24Menu() {
    return Markup.keyboard([
        ['Мои команды'],
        ['Битрикс Вкл','Битрикс Выкл'],
        ['Статус Битрикс'],
        ['Бьюик']
    ]).resize().extra()
}

function getMainMenu() {
    return Markup.keyboard([
        ['Мои файлы', 'Скачать файл'],
        ['Очистить поиск'],
        ['Смотивируй меня']
    ]).resize().extra()
}

function getStartMenu() {
    return Markup.keyboard([
        ['Мои команды'],
        ['Бьюик']
   ]).resize().extra()
}

function getRecMenu() {
    return Markup.keyboard([
        ['Мои файлы', 'Скачать файл'],
        ['Очистить поиск'],
        ['Мои команды'],
        ['Бьюик']
   ]).resize().extra()
}

function yesNoKeyboard() {
    return Markup.inlineKeyboard([
        Markup.callbackButton('Да', 'yes'),
        Markup.callbackButton('Нет', 'no')
    ], {columns: 2}).extra()
}

function aaa(actx){
let liner = new lineByLine('access.js')
let line

while(line = liner.next()){
    let string = line.toString()
	let str = string.split('|') 

	
if(actx.from.id == str[0] && actx.from.first_name == str[1] && actx.from.username == str[2]){ 
logger(actx,'Auth')
console.log('**********',actx.message.chat.id)
let ind_chat=0
CHAT_ID.forEach((el) =>{
if(actx.message.chat.id == el){ind_chat +=1 }
})
if(ind_chat == 0){
//logger(actx,'NoAuth');   
logger(actx,'OUT OF GROUP: ' + actx.message.chat.id); 
return -1; }

return 0} 
	
}
logger(actx,'NoAuth')
return -1

}

function logger(lctx,authorizate){
let dt = dateFormat( new Date(), "yyyy-mm-dd HH:MM:ss" )
//console.log(lctx)
let str = dt +"  "+ lctx.from.id + '   ' + "  " + lctx.from.first_name + "  " + 
lctx.from.username + " " + 'cmd:' + 
lctx.message.text + ' | ' + authorizate +  '\n'

fs.appendFileSync("logger.log",str)
}


module.exports = {
aaa:aaa,
getStartMenu:getStartMenu,
getMainMenu:getMainMenu,
getRecMenu:getRecMenu,
getBx24Menu:getBx24Menu,
yesNoKeyboard:yesNoKeyboard,
logger:logger
}



